clear
%Initialise constants
v_bC=3.5;    %dL
v_bT=4.5;    %dL
v_hC=13.8;   %dL
v_sC=11.2;   %dL
v_lC=25.1;   %dL
v_kC=6.6;    %dL
v_pC=10.4;   %dL
v_pT=67.4;   %dL
V_bC=0.265;  %L
V_hC=0.985;  %L
V_sC=0.945;  %L
V_lC=1.14;   %L
V_kC=0.505;  %L
V_pC=0.735;  %L
V_pT=6.3;    %L
V_n=9.93;    %L
q_b=5.9;     %dL/min
q_h=43.7;    %dL/min
q_s=10.1;    %dL/min
q_l=12.6;    %dL/min
q_a=2.5;     %dL/min
q_k=10.1;    %dL/min
q_p=15.1;    %dL/min
Q_b=0.45;    %L/min
Q_h=3.12;    %L/min
Q_s=0.72;    %L/min
Q_l=0.9;     %L/min
Q_a=0.18;    %L/min
Q_k=0.72;    %L/min
Q_p=1.05;    %L/min
F_pnc=0.910; %L/min
T_b=2.1;     %min
T_pG=5.0;    %min
T_pI=20;     %min
F_kC=0.3;
F_lC = 0.4;
F_pC = 0.15;
Gamma_bu=70; %constant
Gamma_rbcu=10; %constant
Gamma_su=20; %constant
Gamma_meal=166.667;
Gamma_kc=13.161;
Gamma_ke=0;
Gamma_lc=28.515;
Gamma_pc=8.3239;
Gamma_pgu=97.79;
Gamma_pir=0; %No pancreatic insulin release
Gamma_pnr=3.1776;
Gamma_sia=0; %no insulin given at subcut depot
Gamma_ivi=-50;

%Initialise variables
syms G_bC G_bT G_hC G_sC G_lC G_kC G_pC G_pT A_ihgp A_nhgp A_ihgu I_bC I_hC I_sC I_lC I_kC I_pC I_pT N


f = [(G_hC-G_bC)*q_b/v_bC-(G_bC-G_bT)*(v_bT/(T_b*v_bC));                    %1
     (G_bC-G_bT)/T_b-Gamma_bu/v_bT;                                         %2
     (G_bC*q_b+G_lC*q_l+G_kC*q_k+G_pC*q_p-G_hC*q_h-Gamma_rbcu)/v_hC;        %3
     (G_hC-G_sC)*q_s/v_sC+Gamma_meal/v_sC-Gamma_su/v_sC;                    %4
     (G_hC*q_a+G_sC*q_s-G_lC*q_l)/v_lC+(155*A_ihgp*[2.7*tanh(0.388*N)-A_nhgp]*[1.425-1.406*tanh(0.6199*(G_lC/101-0.4969))])/v_lC-(20*A_ihgu*[5.6648+5.6589*tanh(2.4375*(G_lC/101-1.48))])/v_lC;       %5
     (G_hC-G_kC)*q_k/v_kC-(71+71*tanh(0.011*(G_kC-460)))/v_kC;              %6 Note: For our operating pt. G_kC<460mg/dL
     (G_hC-G_pC)*q_p/v_pC+(G_pT-G_pC)*v_pT/(T_pG*v_pC);                     %7
     (G_pC-G_pT)/T_pG-((35*G_pT)/86.81*[7.035+6.51623*tanh(0.33827*(I_pT/5.304-5.82113))])/v_pT;                                       %8
     1/25*[1.2088-1.138*tanh(1.669*I_lC/21.43-0.8885)-A_ihgp];              %9
     1/65*[(2.7*tanh(0.388*N)-1)/2-A_nhgp];                                 %10
     1/25*(2*tanh(0.549*I_lC/21.43)-A_ihgu);                                %11
     (I_hC-I_bC)*Q_b/V_bC;                                                  %12
     (I_bC*Q_b+I_lC*Q_l+I_kC*Q_k+I_pC*Q_p-I_hC*Q_h-Gamma_ivi)/V_hC;         %13
     (I_hC-I_sC)*Q_s/V_sC;                                                  %14    
     (I_hC*Q_a+I_sC*Q_s-I_lC*Q_l)/V_lC+(Gamma_pir-(F_lC*(I_hC*Q_a+I_sC*Q_s+Gamma_pir)))/V_lC  ;         %15
     (I_hC-I_kC)*Q_k/V_kC-(F_kC*I_kC*Q_k)/V_kC;                                    %16
     (I_hC-I_pC)*Q_p/V_pC-(I_pC-I_pT)*V_pT/(T_pI*V_pC);                     %17
     (I_pC-I_pT)/T_pI+(Gamma_sia-I_pT/((1-F_pC)/F_pC*1/Q_p-1/(T_pI*V_pT)))/V_pT;                            %18
     ([1.3102-0.61016*tanh(1.0571*(I_hC/15.15-0.46981))]*[2.9285-2.095*tanh(4.18*(G_hC/91.89-0.6191))]-N)*F_pnc/V_n                                                %19
 
     ];
 
v = [G_bC, G_bT, G_hC, G_sC, G_lC, G_kC, G_pC, G_pT, A_ihgp, A_nhgp, A_ihgu, I_bC, I_hC, I_sC, I_lC, I_kC, I_pC, I_pT, N];        


J = jacobian(f,v)
